clear 
clc


exec("nombres.sce",-1);

////////////
// PART 1 //
////////////

mprintf("\n\n --------\n| PART 1 |\n --------\n");

// creation de differentes variables
a = 1.;
b = 0.3;
c = 10.^100;
d = exp(-20.);
e = sqrt(2.);

// affichage des variables avec 'disp'
disp("Affichage de différentes valeurs avec disp :")
disp(a);
disp(b);
disp(c);
disp(d);
disp(e);

// affichage des variables avec mprintf'
disp("Affichage de e = sqrt(2) avec mprintf :");
mprintf("e = %10.7f\n",e);
mprintf("e = %15.12f\n",e);
mprintf("e = %20.17f\n",e);

disp("Affichage de b = 0.3 avec mprintf :");
mprintf("b = %10.7f\n",b);
mprintf("b = %15.12f\n",b);
mprintf("b = %20.17f\n",b);
mprintf("b = %60.57f\n",b);

// affichage des variables avec la fonction 'ecrire' disponible dans nombres.sce
disp("Affichage de b et c avec la fonction ''ecrire'' disponible dans nombres.sce")
disp("b = "); ecrire(b);
disp("c = "); ecrire(c);


////////////
// PART 2 //
////////////

mprintf("\n\n --------\n| PART 2 |\n --------\n");

// codage d'un réel sur 64 bits avec 'ecrire_codage64' disponible dans nombres.sce
disp("Codage de réels sur 64 bits :")

// quelques exemples de codages
disp("Codage de -101 :");   ecrire_codage64(-101); 
disp("Codage de 0.3 :");    ecrire_codage64(0.3);
disp("Codage de 0 :");      ecrire_codage64(0); 

// codage de v = 1, 2v and v/2 
// => la mantisse de ces trois valeurs est la meme, seul l'exposant change
disp("Codage de 1 :");      ecrire_codage64(1); 
disp("Codage de 2 :");      ecrire_codage64(2); 
disp("Codage de 0.5 :");    ecrire_codage64(0.5); 

// codage de  v = 0.3, 2v and v/2
// => la mantisse de ces trois valeurs est la meme, seul l'exposant change
disp("Codage de 0.3 :");    ecrire_codage64(0.3);
disp("Codage de 0.6 :");    ecrire_codage64(0.6);
disp("Codage de 0.15 :");   ecrire_codage64(0.15);

disp("...................................................................");

// decodage de plusieurs nombres binaires avec 'valeur_reel64' disponible dans nombres.sce
disp("Decodage de plusieurs nombres binaires avec ''valeur_reel64'' disponible dans nombres.sce")
exec("ex1.sce",-1);

disp("...................................................................");

// mise en évidence de la précision machine ~ 10^(-16)
disp("Mise en evidence de la precision machine :");
mprintf("\n Codage de %12.11f :\n", 4.0);        
ecrire_codage64(4.0);
for k = 1:16
    t = 4.0 + 10^(-k);
    mprintf("\n Codage de %17.16g = 4.0 + 10^(-%2i) :\n", t, k);
    ecrire_codage64(t);
end
// => lorsqu'on ajoute 10^(-16) à 4, l'ordinateur code 4 + 10^(-16) exactement comme 4


////////////
// PART 3 //
////////////

mprintf("\n\n --------\n| PART 3 |\n --------\n");

// test de la precision des calculs : valeur attendue r1 = 0
r1 = 0.9 - 0.6 - 0.3;
disp("Valeur de r1 = 0.9 - 0.6 - 0.3 (valeur attendue r1 = 0) :"); disp(r1);

disp("Mise en évidence des erreurs faites par l''ordinateur dans le calcul de 0.9-0.6-0.3 :")
disp("Valeur de 0.3 :");        ecrire(0.3);
disp("Valeur de 0.6 :");        ecrire(0.6);
disp("Valeur de 0.9 :");        ecrire(0.9);
disp("Valeur de 0.9-0.6 :");    ecrire(0.9-0.6);

// autre test de la precision des calculs suivant l'ordre des operations : valeur attendue r2 = 0
r2 = 0.9 - 0.3 - 0.6;
disp("Valeur de r2 = 0.9 - 0.3 - 0.6 (valeur attendue r2 = r1 = 0) : "); disp(r2);

disp("...................................................................");

disp("Accumulation des erreurs dans les boucles :")
// ex 1 d'accumulation d'erreur dans une boucle
disp("ex 1 d''accumulation d''erreur dans une boucle : calcul de s = 0 + 0.3*100000 - 3*10000");
exec("ex_numerique1.sce",-1);

// ex 2 d'accumulation d'erreur dans une boucle
disp("ex 2 d''accumulation d''erreur dans une boucle : calcul de b/(2^k)");
exec("ex_numerique2.sce",-1);

disp("...................................................................");

// calcul d'une valeur approchée de pi
exec("ex_suite_pi.sce",-1);
